<?php
/**
 * Created by PhpStorm.
 * User: phillipesilva
 * Date: 04/02/2016
 * Time: 08:32
 */

namespace Factory;

use Zeedhi\DevOps\Model\Servermanager\Entities\ProductServer;
use Zeedhi\DevOps\Model\Configurationmanager\Entities\Release as ReleaseEntity;
use Zeedhi\DevOps\Model\Configurationmanager\Entities\Subrelease as SubreleaseEntity;

class Subrelease {
    /**
     * @param SubreleaseEntity $subrelease
     * @param ProductServer $productServer
     * @param ReleaseEntity $release
     * @param $project
     * @param $name
     * @param $status
     * @param $description
     * @param $branchToDeploy
     * @param $version
     * @param $revision
     * @param $build
     * @param $pathToTest
     * @param $urlToTest
     * @param $isActive
     * @param $releaseProductServerId
     * @return SubreleaseEntity
     */
    public function setSubreleaseRecords($subrelease, ProductServer $productServer, ReleaseEntity $release, $project, $name,
                                         $status, $description, $branchToDeploy, $version, $revision, $build, $pathToTest,
                                         $urlToTest, $isActive, $releaseProductServerId)
    {
        if(!$subrelease) {
            $subrelease = new SubreleaseEntity();
        }

        $subrelease->setName($name);
        $subrelease->setStatus($status);
        $subrelease->setDescription($description);
        $subrelease->setBranchToDeploy($branchToDeploy);
        $subrelease->setVersion($version);
        $subrelease->setRevision($revision);
        $subrelease->setBuild($build);
        $subrelease->setPathToTest($pathToTest);
        $subrelease->setProductServer($productServer);
        $subrelease->setRelease($release);
        $subrelease->setProject($project);
        $subrelease->setUrlToTest($urlToTest);
        $subrelease->setIsActive($isActive);
        $subrelease->setReleaseProductServerId($releaseProductServerId);

        return $subrelease;
    }
} 