<?php
namespace Util\Instance;

use Zeedhi\DevOps\Util\Utilities;
use Util\InstanceProvider;
use Zeedhi\DevOps\Model\Projectmanagement\Repositories;
use Zeedhi\DevOps\Model\Profile\Repositories as ProfileRepositories;


class Repository {

    /** @return  Repository */
    public static function getInstance()
    {
        return new static();
    }

    /** @return  Repositories\Resource */
    public function getResource()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::PROJECT_MANAGEMENT_ENTITY_DIR . 'Resource');
    }

    /** @return  Repositories\Task */
    public function getTask()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::PROJECT_MANAGEMENT_ENTITY_DIR . 'Task');
    }

    /** @return  Repositories\TaskTypeProjectType */
    public function getTaskTypeProjectType()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::PROJECT_MANAGEMENT_ENTITY_DIR . 'TaskTypeProjectType');
    }

    /** @return  Repositories\ProjectType */
    public function getProjectType()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::PROJECT_MANAGEMENT_ENTITY_DIR . 'ProjectType');
    }
    /** @return  Repositories\WorkedTime */
    public function getWorkedTime()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::PROJECT_MANAGEMENT_ENTITY_DIR . 'WorkedTime');
    }
    /** @return  \Teknisa\Model\Geral\Repositories\Perfacessparc */
    public function getPerfacessparc()
    {
        return InstanceProvider::getEntityManager()->getRepository('\Teknisa\Model\Geral\Entities\Perfacessparc');
    }
    /** @return  \Teknisa\Model\Geral\Repositories\Perfilacesso */
    public function getPerfilacesso()
    {
        return InstanceProvider::getEntityManager()->getRepository('\Teknisa\Model\Geral\Entities\Perfilacesso');
    }
    /** @return  Repositories\Profile */
    public function getProfile()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::PROJECT_MANAGEMENT_ENTITY_DIR . 'Profile');
    }
    /** @return  Repositories\Rule */
    public function getRule()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::PROJECT_MANAGEMENT_ENTITY_DIR . 'Rule');
    }

    /** @return  Repositories\PartnerProfile */
    public function getPartnerProfile()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::PROJECT_MANAGEMENT_ENTITY_DIR . 'PartnerProfile');
    }

    /** @return  \Zeedhi\DevOps\Model\Configurationmanager\Repositories\Branch */
    public function getBranch()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::CONFIGURATION_MANAGER_ENTITY_DIR . 'Branch');
    }

    /** @return  \Zeedhi\DevOps\Model\Configurationmanager\Repositories\ErrorRepository */
    public function getErrorRepository()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::CONFIGURATION_MANAGER_ENTITY_DIR . 'ErrorRepository');
    }
    
    public function getTaskStatus()
    {
        return InstanceProvider::getEntityManager()->getRepository('\Zeedhi\DevOps\Model\Projectmanagement\Entities\TaskStatus');
    }
    
    public function getProductServer()
    {
        return InstanceProvider::getEntityManager()->getRepository('\Zeedhi\DevOps\Model\Servermanager\Entities\ProductServer');
    }

    /** @return  \Zeedhi\DevOps\Model\Devops\Repositories\ProductVersion */
    public function getProductVersion()
    {
        return InstanceProvider::getEntityManager()->getRepository('\Zeedhi\DevOps\Model\Devops\Entities\ProductVersion');
    }
    
    /** @return  \Zeedhi\DevOps\Model\Devops\Repositories\ProductVersionProducts */
    public function getProductVersionProducts()
    {
        return InstanceProvider::getEntityManager()->getRepository('\Zeedhi\DevOps\Model\Devops\Entities\ProductVersionProducts');
    }
    
    /** @return  \Zeedhi\DevOps\Model\Devops\Repositories\ProductVersionProducts */
    public function getConfigurationLog()
    {
        return InstanceProvider::getEntityManager()->getRepository('\Zeedhi\DevOps\Model\Devops\Entities\ConfigurationLog');
    }

    /** @return  \Zeedhi\DevOps\Model\Configurationmanager\Repositories\Product */
    public function getProduct()
    {
        return InstanceProvider::getEntityManager()->getRepository('\Zeedhi\DevOps\Model\Configurationmanager\Entities\Product');
    }

    /** @return  Repositories\TaskProperties */
    public function getTaskProperties()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::PROJECT_MANAGEMENT_ENTITY_DIR . 'TaskProperties');
    }

    /** @return  ProfileRepositories\ZhUser */
    public function getZhUser()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::PROFILE_ENTITY_DIR . 'ZhUser');
    }

    /** @return  \Zeedhi\DevOps\Model\Projectmanagement\Repositories\Repository */
    public function getRepository()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::PROJECT_MANAGEMENT_ENTITY_DIR . 'Repository');
    }

    /** @return  \Zeedhi\DevOps\Model\Projectmanagement\Repositories\Attachment */
    public function getAttachment()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::PROJECT_MANAGEMENT_ENTITY_DIR . 'Attachment');
    }
}