'4.11.105';
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na
tabela PARGERALDFE */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela PARGERALDFE,
utilizando a tabela Geral de Logs de Operaes */



IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_PARGERALDFE' AND
                 TYPE   = 'TR' 		        AND
	              U.UID  = O.UID             AND
	              U.NAME = USER)
DROP TRIGGER LOG_PARGERALDFE
GO

CREATE TRIGGER LOG_PARGERALDFE
ON PARGERALDFE
FOR INSERT, UPDATE, DELETE

AS
   DECLARE  @V_USUARIO      VARCHAR(40);
   DECLARE  @V_TIPO         VARCHAR(1);
   DECLARE  @V_ITPESQ       VARCHAR(40);
   DECLARE  @V_DESC         VARCHAR(300);
   DECLARE  @V_DTOPER       DATETIME;
/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE  @V_ID_COMANDO       VARCHAR(1);
   DECLARE  @V_CDPARAMDFE_OLD   VARCHAR(1);
   DECLARE  @V_IDIMPAVLANNF_OLD VARCHAR(1);
   DECLARE  @V_CDPARAMDFE_NEW   VARCHAR(1);
   DECLARE  @V_IDIMPAVLANNF_NEW VARCHAR(1);
BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';
   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR

   SELECT 'D'
      IDCOMANDO,
      CDPARAMDFE,
      IDIMPAVLANNF,
      NULL,
      NULL
   FROM
      DELETED
   WHERE
      CDPARAMDFE NOT IN (SELECT CDPARAMDFE FROM INSERTED)
   UNION ALL

   SELECT 'U'
      IDCOMANDO,
      DELETED.CDPARAMDFE,
      DELETED.IDIMPAVLANNF,
      INSERTED.CDPARAMDFE,
      INSERTED.IDIMPAVLANNF
   FROM
      INSERTED,
      DELETED
   WHERE
      INSERTED.CDPARAMDFE = DELETED.CDPARAMDFE
   UNION ALL

   SELECT 'I'
      IDCOMANDO,
      NULL,
      NULL,
      CDPARAMDFE,
      IDIMPAVLANNF
   FROM
      INSERTED
   WHERE
      CDPARAMDFE NOT IN (SELECT CDPARAMDFE FROM DELETED)
   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_CDPARAMDFE_OLD,
                                 @V_IDIMPAVLANNF_OLD,
                                 @V_CDPARAMDFE_NEW,
                                 @V_IDIMPAVLANNF_NEW;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'D'  BEGIN
         IF @V_IDIMPAVLANNF_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'UtilImprAutom=' + @V_IDIMPAVLANNF_OLD;
         END;

         SET @V_TIPO         = '3';
         SET @V_ITPESQ       = @V_CDPARAMDFE_OLD;
      END
      ELSE BEGIN
         IF @V_ID_COMANDO = 'U'/*UPDATING*/ BEGIN
            IF (@V_IDIMPAVLANNF_OLD <> @V_IDIMPAVLANNF_NEW) BEGIN
               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_CDPARAMDFE_OLD;
            END;
         END
         ELSE BEGIN
            SET @V_TIPO         = '1';
            SET @V_ITPESQ       = @V_CDPARAMDFE_NEW;
         END;
         IF @V_IDIMPAVLANNF_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'UtilImprAutom=' + @V_IDIMPAVLANNF_NEW;
         END;
      END;

      IF @V_TIPO <> '0' BEGIN
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();
               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER,
                   IDTIPOOPER, CDPESQITEM, DSOPERACAO)
               VALUES
                  ('PARGERALDFE',  @V_DTOPER, @V_USUARIO,
                   @V_TIPO,      @V_ITPESQ, @V_DESC);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @V_CDPARAMDFE_OLD,
                                    @V_IDIMPAVLANNF_OLD,
                                    @V_CDPARAMDFE_NEW,
                                    @V_IDIMPAVLANNF_NEW;

   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
 GO

 -- VERSAO --
 EXEC ATUVEROBJ 'LOG_PARGERALDFE','4.09.044';
 GO

