/*
Nome: 9812_CDPTRGS_LOG_CDP_COMPPROD.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   17/02/2009 - Henrique Guidi Lobato
Descrio: A trigger insere registros na tabela LOGOPERA a partir das alteraes na tabela
              COMPPROD, para verifio de erros */
IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'LOG_CDP_COMPPROD' AND
                TYPE   = 'TR'               AND
                U.UID  = O.UID              AND
                U.NAME = USER)

DROP TRIGGER LOG_CDP_COMPPROD
GO


CREATE TRIGGER LOG_CDP_COMPPROD
ON COMPPROD
FOR UPDATE,INSERT, DELETE
AS
BEGIN

   DECLARE @V_DSREMOTEADDR VARCHAR(15);
   DECLARE @V_DSREMOTEHOST VARCHAR(15);
   DECLARE @V_DSSERVERRDM  VARCHAR(20);
   DECLARE @V_DSSERVMETHOD VARCHAR(30);
   DECLARE @V_DSREMOTEOPER VARCHAR(12);
   DECLARE @V_DESC         VARCHAR(2000);
   DECLARE @V_ITPESQ       VARCHAR(80);
   DECLARE @V_NMOPERADOR   VARCHAR(40);
   DECLARE @V_IDCLIEATIV   VARCHAR(1);
   DECLARE @V_NRINCREST    VARCHAR(40);
   DECLARE @V_IDTIPOOPER   VARCHAR(1);

/*VARIVEIS DO CURSOR C_CURSOR*/
   DECLARE @V_ID_TRIGGER       VARCHAR(1);

   DECLARE @V_CDPRODUTO_OLD      VARCHAR(10);
   DECLARE @V_CDESPEPROD_OLD     VARCHAR(10);
   DECLARE @V_CDTIPOCOMP_OLD     VARCHAR(3);
   DECLARE @V_CDPRODINSUMO_OLD   VARCHAR(10);
   DECLARE @V_IDUTAPROVREQ_OLD   VARCHAR(1);
   DECLARE @V_QTINSUMO_OLD       double precision;
   DECLARE @V_CDTIPOINSU_OLD     VARCHAR(3);
   DECLARE @V_SGUNIDADE_OLD      VARCHAR(10);
   DECLARE @V_IDSEMIACCOMP_OLD   VARCHAR(1);
   DECLARE @V_IDUTILOTEPR_OLD    VARCHAR(1);
   DECLARE @V_CDPRODUTOAUX_OLD   VARCHAR(10);
   DECLARE @V_CDESPPRODAUX_OLD   VARCHAR(10);
   DECLARE @V_NRORDCOMP_OLD      VARCHAR(3);
   DECLARE @V_TXCOMITCOMP_OLD    VARCHAR(200);
   DECLARE @V_IDIMPCOMPDEL_OLD   VARCHAR(1);
   DECLARE @V_VRLOADCOMP_OLD     double precision;
   DECLARE @V_DSLOADCOMP_OLD     VARCHAR(20);
   DECLARE @V_QTBRUTINSPRO_OLD   double precision;
   DECLARE @V_VRPRENDINSPR_OLD   double precision;
   DECLARE @V_VRCUSTPRODMM_OLD   double precision;
   DECLARE @V_VRCUSTEQUIMM_OLD   double precision;
   DECLARE @V_VRCUSTRDELMM_OLD   double precision;

   DECLARE @V_CDPRODUTO_NEW      VARCHAR(10);
   DECLARE @V_CDESPEPROD_NEW     VARCHAR(10);
   DECLARE @V_CDTIPOCOMP_NEW     VARCHAR(3);
   DECLARE @V_CDPRODINSUMO_NEW   VARCHAR(10);
   DECLARE @V_IDUTAPROVREQ_NEW   VARCHAR(1);
   DECLARE @V_QTINSUMO_NEW       double precision;
   DECLARE @V_CDTIPOINSU_NEW     VARCHAR(3);
   DECLARE @V_SGUNIDADE_NEW      VARCHAR(10);
   DECLARE @V_IDSEMIACCOMP_NEW   VARCHAR(1);
   DECLARE @V_IDUTILOTEPR_NEW    VARCHAR(1);
   DECLARE @V_CDPRODUTOAUX_NEW   VARCHAR(10);
   DECLARE @V_CDESPPRODAUX_NEW   VARCHAR(10);
   DECLARE @V_NRORDCOMP_NEW      VARCHAR(3);
   DECLARE @V_TXCOMITCOMP_NEW    VARCHAR(200);
   DECLARE @V_IDIMPCOMPDEL_NEW   VARCHAR(1);
   DECLARE @V_VRLOADCOMP_NEW     double precision;
   DECLARE @V_DSLOADCOMP_NEW     VARCHAR(20);
   DECLARE @V_QTBRUTINSPRO_NEW   double precision;
   DECLARE @V_VRPRENDINSPR_NEW   double precision;
   DECLARE @V_VRCUSTPRODMM_NEW   double precision;
   DECLARE @V_VRCUSTEQUIMM_NEW   double precision;
   DECLARE @V_VRCUSTRDELMM_NEW   double precision;


/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   SET @V_DESC        = '';
   SET @V_ITPESQ      = '';
   SET @V_NMOPERADOR  = '';
   SET @V_IDCLIEATIV  = '';
   SET @V_NRINCREST   = '';
   SET @V_IDTIPOOPER  = '';

   EXEC NMUSUARIO  @V_NMOPERADOR;
   EXEC WEBTUNNING @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVERRDM,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER;

   DECLARE C_CURSOR CURSOR FOR
      SELECT
         'D' IDCOMANDO,
         CDPRODUTO,
         CDESPEPROD,
         CDTIPOCOMP,
         CDPRODINSUMO,
         IDUTAPROVREQ,
	 QTINSUMO,
	 CDTIPOINSU,
	 SGUNIDADE,
	 IDSEMIACCOMP,
         IDUTILOTEPR,
	 CDPRODUTOAUX,
	 CDESPPRODAUX,
	 NRORDCOMP,
	 TXCOMITCOMP,
	 IDIMPCOMPDEL,
	 VRLOADCOMP,
	 DSLOADCOMP,
	 QTBRUTINSPRO,
	 VRPRENDINSPR,
	 VRCUSTPRODMM,
         VRCUSTEQUIMM,
         VRCUSTRDELMM,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL

      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)
      UNION ALL

      SELECT
         'U' IDCOMANDO,
         DELETED.CDPRODUTO,
         DELETED.CDESPEPROD,
         DELETED.CDTIPOCOMP,
         DELETED.CDPRODINSUMO,
         DELETED.IDUTAPROVREQ,
	 DELETED.QTINSUMO,
	 DELETED.CDTIPOINSU,
	 DELETED.SGUNIDADE,
	 DELETED.IDSEMIACCOMP,
         DELETED.IDUTILOTEPR,
	 DELETED.CDPRODUTOAUX,
	 DELETED.CDESPPRODAUX,
	 DELETED.NRORDCOMP,
	 DELETED.TXCOMITCOMP,
	 DELETED.IDIMPCOMPDEL,
	 DELETED.VRLOADCOMP,
	 DELETED.DSLOADCOMP,
	 DELETED.QTBRUTINSPRO,
	 DELETED.VRPRENDINSPR,
	 DELETED.VRCUSTPRODMM,
         DELETED.VRCUSTEQUIMM,
         DELETED.VRCUSTRDELMM,
         INSERTED.CDPRODUTO,
         INSERTED.CDESPEPROD,
         INSERTED.CDTIPOCOMP,
         INSERTED.CDPRODINSUMO,
         INSERTED.IDUTAPROVREQ,
	 INSERTED.QTINSUMO,
	 INSERTED.CDTIPOINSU,
	 INSERTED.SGUNIDADE,
	 INSERTED.IDSEMIACCOMP,
         INSERTED.IDUTILOTEPR,
	 INSERTED.CDPRODUTOAUX,
	 INSERTED.CDESPPRODAUX,
	 INSERTED.NRORDCOMP,
	 INSERTED.TXCOMITCOMP,
	 INSERTED.IDIMPCOMPDEL,
	 INSERTED.VRLOADCOMP,
	 INSERTED.DSLOADCOMP,
	 INSERTED.QTBRUTINSPRO,
	 INSERTED.VRPRENDINSPR,
	 INSERTED.VRCUSTPRODMM,
         INSERTED.VRCUSTEQUIMM,
         INSERTED.VRCUSTRDELMM

      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDPRODUTO  = DELETED.CDPRODUTO

      UNION ALL

      SELECT
        'I' IDCOMANDO,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         CDPRODUTO,
         CDESPEPROD,
         CDTIPOCOMP,
         CDPRODINSUMO,
         IDUTAPROVREQ,
	 QTINSUMO,
	 CDTIPOINSU,
	 SGUNIDADE,
	 IDSEMIACCOMP,
         IDUTILOTEPR,
	 CDPRODUTOAUX,
	 CDESPPRODAUX,
	 NRORDCOMP,
	 TXCOMITCOMP,
	 IDIMPCOMPDEL,
	 VRLOADCOMP,
	 DSLOADCOMP,
	 QTBRUTINSPRO,
	 VRPRENDINSPR,
	 VRCUSTPRODMM,
         VRCUSTEQUIMM,
         VRCUSTRDELMM

     FROM
        INSERTED
     WHERE
        0 = (SELECT COUNT(*) FROM DELETED)

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_TRIGGER,

    				 @V_CDPRODUTO_OLD,
                                 @V_CDESPEPROD_OLD,
                                 @V_CDTIPOCOMP_OLD,
                                 @V_CDPRODINSUMO_OLD,
    				 @V_IDUTAPROVREQ_OLD,
    				 @V_QTINSUMO_OLD,
    				 @V_CDTIPOINSU_OLD,
    				 @V_SGUNIDADE_OLD,
    				 @V_IDSEMIACCOMP_OLD,
    				 @V_IDUTILOTEPR_OLD,
    				 @V_CDPRODUTOAUX_OLD,
    				 @V_CDESPPRODAUX_OLD,
    				 @V_NRORDCOMP_OLD,
    				 @V_TXCOMITCOMP_OLD,
    				 @V_IDIMPCOMPDEL_OLD,
    				 @V_VRLOADCOMP_OLD,
    				 @V_DSLOADCOMP_OLD,
    				 @V_QTBRUTINSPRO_OLD,
    				 @V_VRPRENDINSPR_OLD,
    				 @V_VRCUSTPRODMM_OLD,
				 @V_VRCUSTEQUIMM_OLD,
    				 @V_VRCUSTRDELMM_OLD,

				 @V_CDPRODUTO_NEW,
    				 @V_CDESPEPROD_NEW,
    				 @V_CDTIPOCOMP_NEW,
    				 @V_CDPRODINSUMO_NEW,
    				 @V_IDUTAPROVREQ_NEW,
    				 @V_QTINSUMO_NEW,
    				 @V_CDTIPOINSU_NEW,
    				 @V_SGUNIDADE_NEW,
    				 @V_IDSEMIACCOMP_NEW,
    				 @V_IDUTILOTEPR_NEW,
    				 @V_CDPRODUTOAUX_NEW,
    				 @V_CDESPPRODAUX_NEW,
    				 @V_NRORDCOMP_NEW,
    	  			 @V_TXCOMITCOMP_NEW,
    				 @V_IDIMPCOMPDEL_NEW,
    				 @V_VRLOADCOMP_NEW,
    				 @V_DSLOADCOMP_NEW,
    				 @V_QTBRUTINSPRO_NEW,
    				 @V_VRPRENDINSPR_NEW,
    				 @V_VRCUSTPRODMM_NEW,
    			 	 @V_VRCUSTEQUIMM_NEW,
    				 @V_VRCUSTRDELMM_NEW;

   WHILE (@@FETCH_STATUS = 0) BEGIN

    IF @V_ID_TRIGGER = 'I' BEGIN

         IF @V_CDPRODUTO_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'CdProd= ' + ISNULL(@V_CDPRODUTO_NEW,'') + ' ';
         END;

         IF @V_CDESPEPROD_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'CdEspecificProd= ' + ISNULL(@V_CDESPEPROD_NEW,'') + ' ';
         END;

         IF @V_CDTIPOCOMP_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'CdTipoComposicao= ' + ISNULL(@V_CDTIPOCOMP_NEW,'') + ' ';
         END;

         IF @V_CDPRODINSUMO_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'CdProdInsumo= ' + ISNULL(@V_CDPRODINSUMO_NEW,'') + ' ';
         END;

         IF @V_IDUTAPROVREQ_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'IdUtProdLoteCalcReq= ' + ISNULL(@V_IDUTAPROVREQ_NEW,'') + ' ';
         END;

         IF @V_QTINSUMO_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'QtInsumo= ' + RTRIM(CONVERT(CHAR, @V_QTINSUMO_NEW)) + ' ';
         END;

         IF @V_CDTIPOINSU_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'CdTipoInsumo= ' + @V_CDTIPOINSU_NEW + ' ';
         END;

         IF @V_SGUNIDADE_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'SiglaUnidade= ' + @V_SGUNIDADE_NEW + ' ';
         END;

         IF @V_IDSEMIACCOMP_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'IdProdSemi-Acabado= ' + @V_IDSEMIACCOMP_NEW + ' ';
         END;

         IF @V_IDUTILOTEPR_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'IdUtilizacaoLote= ' + @V_IDUTILOTEPR_NEW + ' ';
         END;

         IF @V_CDPRODUTOAUX_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'CdProdutoAuxiliar= ' + @V_CDPRODUTOAUX_NEW + ' ';
         END;

         IF @V_CDESPPRODAUX_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'CdEspecifiProdAux= ' + @V_CDESPPRODAUX_NEW + ' ';
         END;

         IF @V_NRORDCOMP_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'NrOrdemComposi= ' + @V_NRORDCOMP_NEW + ' ';
         END;

         IF @V_TXCOMITCOMP_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'TxComentItemComposi= ' + @V_TXCOMITCOMP_NEW + ' ';
         END;

         IF @V_IDIMPCOMPDEL_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'IdImpressoDelivery= ' + @V_IDIMPCOMPDEL_NEW + ' ';
         END;

         IF @V_VRLOADCOMP_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'VrLoadingComposicao= ' + RTRIM(CONVERT(CHAR, @V_VRLOADCOMP_NEW)) + ' ';
         END;

         IF @V_DSLOADCOMP_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'DsLoadingComposicao= ' + @V_DSLOADCOMP_NEW + ' ';
         END;

         IF @V_QTBRUTINSPRO_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'QtBurtaInsumoProduc= ' + RTRIM(CONVERT(CHAR, @V_QTBRUTINSPRO_NEW)) + ' ';
         END;

         IF @V_VRPRENDINSPR_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'VrPercentRendimentoProd= ' + RTRIM(CONVERT(CHAR, @V_VRPRENDINSPR_NEW)) + ' ';
         END;

         IF @V_VRCUSTPRODMM_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'VrCustoProducMin= ' + RTRIM(CONVERT(CHAR, @V_VRCUSTPRODMM_NEW)) + ' ';
         END;

         IF @V_VRCUSTPRODMM_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'VrCustoProducMin= ' + RTRIM(CONVERT(CHAR, @V_VRCUSTPRODMM_NEW)) + ' ';
         END;

         IF @V_VRCUSTRDELMM_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'VrCustRampDeliveryMin= ' + RTRIM(CONVERT(CHAR, @V_VRCUSTRDELMM_NEW)) + ' ';
         END;

        SET @V_ITPESQ = @V_CDPRODUTO_NEW + @V_CDESPEPROD_NEW + @V_CDTIPOCOMP_NEW + @V_CDPRODINSUMO_NEW;

        SET @V_IDTIPOOPER = '1';

     END
     ELSE BEGIN

        IF @V_ID_TRIGGER = 'U' BEGIN

         IF (@V_CDPRODUTO_OLD <> @V_CDPRODUTO_NEW) BEGIN
            SET @V_DESC = @V_DESC + 'CdProd= ' + ISNULL(@V_CDPRODUTO_NEW,'') + ' ';
         END;

         IF (@V_CDESPEPROD_OLD <> @V_CDESPEPROD_NEW) BEGIN
            SET @V_DESC = @V_DESC + 'CdEspecificProd= ' + ISNULL(@V_CDESPEPROD_NEW,'') + ' ';
         END;

         IF (@V_CDTIPOCOMP_OLD <> @V_CDTIPOCOMP_NEW) BEGIN
            SET @V_DESC = @V_DESC + 'CdTipoComposicao= ' + ISNULL(@V_CDTIPOCOMP_NEW,'') + ' ';
         END;

         IF (@V_CDPRODINSUMO_OLD <> @V_CDPRODINSUMO_NEW) BEGIN
            SET @V_DESC = @V_DESC + 'CdProdInsumo= ' + ISNULL(@V_CDPRODINSUMO_NEW,'') + ' ';
         END;

         IF (@V_IDUTAPROVREQ_OLD <> @V_IDUTAPROVREQ_NEW) BEGIN
            SET @V_DESC = @V_DESC + 'IdUtProdLoteCalcReq= ' + ISNULL(@V_IDUTAPROVREQ_NEW,'') + ' ';
         END;

         IF (@V_QTINSUMO_OLD <> @V_QTINSUMO_NEW) BEGIN
            SET @V_DESC = @V_DESC + 'QtInsumo= ' + RTRIM(CONVERT(CHAR, @V_QTINSUMO_NEW)) + ' ';
         END;

         IF (ISNULL(@V_CDTIPOINSU_OLD,'-1') <> ISNULL(@V_CDTIPOINSU_NEW,'-1')) BEGIN
            SET @V_DESC = @V_DESC + 'CdTipoInsumo= ' + @V_CDTIPOINSU_NEW + ' ';
         END;

         IF (ISNULL(@V_SGUNIDADE_OLD,'-1') <> ISNULL(@V_SGUNIDADE_NEW,'-1')) BEGIN
            SET @V_DESC = @V_DESC + 'SiglaUnidade= ' + @V_SGUNIDADE_NEW + ' ';
         END;

         IF (ISNULL(@V_IDSEMIACCOMP_OLD,'-1') <> ISNULL(@V_IDSEMIACCOMP_NEW,'-1')) BEGIN
            SET @V_DESC = @V_DESC + 'IdProdSemi-Acabado= ' + @V_IDSEMIACCOMP_NEW + ' ';
         END;

         IF (ISNULL(@V_IDUTILOTEPR_OLD,'-1') <> ISNULL(@V_IDUTILOTEPR_NEW,'-1')) BEGIN
            SET @V_DESC = @V_DESC + 'IdUtilizacaoLote= ' + @V_IDUTILOTEPR_NEW + ' ';
         END;

         IF (ISNULL(@V_CDPRODUTOAUX_OLD,'-1') <> ISNULL(@V_CDPRODUTOAUX_NEW,'-1')) BEGIN
            SET @V_DESC = @V_DESC + 'CdProdutoAuxiliar= ' + @V_CDPRODUTOAUX_NEW + ' ';
         END;

         IF (ISNULL(@V_CDESPPRODAUX_OLD,'-1') <> ISNULL(@V_CDESPPRODAUX_NEW,'-1')) BEGIN
            SET @V_DESC = @V_DESC + 'CdEspecifiProdAux= ' + @V_CDESPPRODAUX_NEW + ' ';
         END;

         IF (ISNULL(@V_NRORDCOMP_OLD,'-1') <> ISNULL(@V_NRORDCOMP_NEW,'-1')) BEGIN
            SET @V_DESC = @V_DESC + 'NrOrdemComposi= ' + @V_NRORDCOMP_NEW + ' ';
         END;

         IF (ISNULL(@V_TXCOMITCOMP_OLD,'-1') <> ISNULL(@V_TXCOMITCOMP_NEW,'-1')) BEGIN
            SET @V_DESC = @V_DESC + 'TxComentItemComposi= ' + @V_TXCOMITCOMP_NEW + ' ';
         END;

         IF (ISNULL(@V_IDIMPCOMPDEL_OLD,'-1') <> ISNULL(@V_IDIMPCOMPDEL_NEW,'-1')) BEGIN
            SET @V_DESC = @V_DESC + 'IdImpressoDelivery= ' + @V_IDIMPCOMPDEL_NEW + ' ';
         END;

         IF (ISNULL(@V_VRLOADCOMP_OLD,'-1') <> ISNULL(@V_VRLOADCOMP_NEW,'-1')) BEGIN
            SET @V_DESC = @V_DESC + 'VrLoadingComposicao= ' + RTRIM(CONVERT(CHAR, @V_VRLOADCOMP_NEW)) + ' ';
         END;

         IF (ISNULL(@V_DSLOADCOMP_OLD,'-1') <> ISNULL(@V_DSLOADCOMP_NEW,'-1')) BEGIN
            SET @V_DESC = @V_DESC + 'DsLoadingComposicao= ' + @V_DSLOADCOMP_NEW + ' ';
         END;

         IF (ISNULL(@V_QTBRUTINSPRO_OLD,'-1') <> ISNULL(@V_QTBRUTINSPRO_NEW,'-1')) BEGIN
            SET @V_DESC = @V_DESC + 'QtBurtaInsumoProduc= ' + RTRIM(CONVERT(CHAR, @V_QTBRUTINSPRO_NEW)) + ' ';
         END;

         IF (ISNULL(@V_VRPRENDINSPR_OLD,'-1') <> ISNULL(@V_VRPRENDINSPR_NEW,'-1')) BEGIN
            SET @V_DESC = @V_DESC + 'VrPercentRendimentoProd= ' + RTRIM(CONVERT(CHAR, @V_VRPRENDINSPR_NEW)) + ' ';
         END;

         IF (ISNULL(@V_VRCUSTPRODMM_OLD,'-1') <> ISNULL(@V_VRCUSTPRODMM_NEW,'-1')) BEGIN
            SET @V_DESC = @V_DESC + 'VrCustoProducMin= ' + RTRIM(CONVERT(CHAR, @V_VRCUSTPRODMM_NEW)) + ' ';
         END;

         IF (ISNULL(@V_VRCUSTPRODMM_OLD,'-1') <> ISNULL(@V_VRCUSTPRODMM_NEW,'-1')) BEGIN
            SET @V_DESC = @V_DESC + 'VrCustoProducMin= ' + RTRIM(CONVERT(CHAR, @V_VRCUSTPRODMM_NEW)) + ' ';
         END;

         IF (ISNULL(@V_VRCUSTRDELMM_OLD,'-1') <> ISNULL(@V_VRCUSTRDELMM_NEW,'-1')) BEGIN
            SET @V_DESC = @V_DESC + 'VrCustRampDeliveryMin= ' + RTRIM(CONVERT(CHAR, @V_VRCUSTRDELMM_NEW)) + ' ';
         END;

         SET @V_ITPESQ = @V_CDPRODUTO_NEW + @V_CDESPEPROD_NEW + @V_CDTIPOCOMP_NEW + @V_CDPRODINSUMO_NEW;

         SET @V_IDTIPOOPER = '2';

        END;

        IF @V_ID_TRIGGER = 'D'  BEGIN

         IF @V_CDPRODUTO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'CdProd= ' + ISNULL(@V_CDPRODUTO_OLD,'') + ' ';
         END;

         IF @V_CDESPEPROD_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'CdEspecificProd= ' + ISNULL(@V_CDESPEPROD_OLD,'') + ' ';
         END;

         IF @V_CDTIPOCOMP_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'CdTipoComposicao= ' + ISNULL(@V_CDTIPOCOMP_OLD,'') + ' ';
         END;

         IF @V_CDPRODINSUMO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'CdProdInsumo= ' + ISNULL(@V_CDPRODINSUMO_OLD,'') + ' ';
         END;

         IF @V_IDUTAPROVREQ_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'IdUtProdLoteCalcReq= ' + ISNULL(@V_IDUTAPROVREQ_OLD,'') + ' ';
         END;

         IF @V_QTINSUMO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'QtInsumo= ' + RTRIM(CONVERT(CHAR, @V_QTINSUMO_OLD)) + ' ';
         END;

         IF @V_CDTIPOINSU_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'CdTipoInsumo= ' + @V_CDTIPOINSU_OLD + ' ';
         END;

         IF @V_SGUNIDADE_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'SiglaUnidade= ' + @V_SGUNIDADE_OLD + ' ';
         END;

         IF @V_IDSEMIACCOMP_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'IdProdSemi-Acabado= ' + @V_IDSEMIACCOMP_OLD + ' ';
         END;

         IF @V_IDUTILOTEPR_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'IdUtilizacaoLote= ' + @V_IDUTILOTEPR_OLD + ' ';
         END;

         IF @V_CDPRODUTOAUX_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'CdProdutoAuxiliar= ' + @V_CDPRODUTOAUX_OLD + ' ';
         END;

         IF @V_CDESPPRODAUX_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'CdEspecifiProdAux= ' + @V_CDESPPRODAUX_OLD + ' ';
         END;

         IF @V_NRORDCOMP_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'NrOrdemComposi= ' + @V_NRORDCOMP_OLD + ' ';
         END;

         IF @V_TXCOMITCOMP_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'TxComentItemComposi= ' + @V_TXCOMITCOMP_OLD + ' ';
         END;

         IF @V_IDIMPCOMPDEL_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'IdImpressoDelivery= ' + @V_IDIMPCOMPDEL_OLD + ' ';
         END;

         IF @V_VRLOADCOMP_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'VrLoadingComposicao= ' + RTRIM(CONVERT(CHAR, @V_VRLOADCOMP_OLD)) + ' ';
         END;

         IF @V_DSLOADCOMP_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'DsLoadingComposicao= ' + @V_DSLOADCOMP_OLD + ' ';
         END;

         IF @V_QTBRUTINSPRO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'QtBurtaInsumoProduc= ' + RTRIM(CONVERT(CHAR, @V_QTBRUTINSPRO_OLD)) + ' ';
         END;

         IF @V_VRPRENDINSPR_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'VrPercentRendimentoProd= ' + RTRIM(CONVERT(CHAR, @V_VRPRENDINSPR_OLD)) + ' ';
         END;

         IF @V_VRCUSTPRODMM_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'VrCustoProducMin= ' + RTRIM(CONVERT(CHAR, @V_VRCUSTPRODMM_OLD)) + ' ';
         END;

         IF @V_VRCUSTPRODMM_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'VrCustoProducMin= ' + RTRIM(CONVERT(CHAR, @V_VRCUSTPRODMM_OLD)) + ' ';
         END;

         IF @V_VRCUSTRDELMM_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'VrCustRampDeliveryMin= ' + RTRIM(CONVERT(CHAR, @V_VRCUSTRDELMM_OLD)) + ' ';
         END;

        SET @V_ITPESQ = @V_CDPRODUTO_OLD + @V_CDESPEPROD_OLD + @V_CDTIPOCOMP_OLD + @V_CDPRODINSUMO_OLD;

           SET @V_IDTIPOOPER = '3';
        END;
     END;

     IF NOT (@V_DESC IS NULL) BEGIN

        INSERT INTO LOGOPERA ( NMTABELA, DTOPERACAO, NMRESPOPER,
                               IDTIPOOPER,   DSOPERACAO, CDPESQITEM,
                               DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                               DSMETUSUOPER, CDORESPOPER)
                    VALUES   ('COMPPROD', GETDATE() , ISNULL(@V_NMOPERADOR,' '),
                               @V_IDTIPOOPER,   @V_DESC, @V_ITPESQ,
                               @V_DSSERVERRDM, @V_DSREMOTEADDR,  @V_DSREMOTEHOST,
                               @V_DSSERVMETHOD,   @V_DSREMOTEOPER);
     END;

   FETCH NEXT FROM C_CURSOR INTO @V_ID_TRIGGER,

    				 @V_CDPRODUTO_OLD,
                                 @V_CDESPEPROD_OLD,
                                 @V_CDTIPOCOMP_OLD,
                                 @V_CDPRODINSUMO_OLD,
    				 @V_IDUTAPROVREQ_OLD,
    				 @V_QTINSUMO_OLD,
    				 @V_CDTIPOINSU_OLD,
    				 @V_SGUNIDADE_OLD,
    				 @V_IDSEMIACCOMP_OLD,
    				 @V_IDUTILOTEPR_OLD,
    				 @V_CDPRODUTOAUX_OLD,
    				 @V_CDESPPRODAUX_OLD,
    				 @V_NRORDCOMP_OLD,
    				 @V_TXCOMITCOMP_OLD,
    				 @V_IDIMPCOMPDEL_OLD,
    				 @V_VRLOADCOMP_OLD,
    				 @V_DSLOADCOMP_OLD,
    				 @V_QTBRUTINSPRO_OLD,
    				 @V_VRPRENDINSPR_OLD,
    				 @V_VRCUSTPRODMM_OLD,
				 @V_VRCUSTEQUIMM_OLD,
    				 @V_VRCUSTRDELMM_OLD,

				 @V_CDPRODUTO_NEW,
    				 @V_CDESPEPROD_NEW,
    				 @V_CDTIPOCOMP_NEW,
    				 @V_CDPRODINSUMO_NEW,
    				 @V_IDUTAPROVREQ_NEW,
    				 @V_QTINSUMO_NEW,
    				 @V_CDTIPOINSU_NEW,
    				 @V_SGUNIDADE_NEW,
    				 @V_IDSEMIACCOMP_NEW,
    				 @V_IDUTILOTEPR_NEW,
    				 @V_CDPRODUTOAUX_NEW,
    				 @V_CDESPPRODAUX_NEW,
    				 @V_NRORDCOMP_NEW,
    	  			 @V_TXCOMITCOMP_NEW,
    				 @V_IDIMPCOMPDEL_NEW,
    				 @V_VRLOADCOMP_NEW,
    				 @V_DSLOADCOMP_NEW,
    				 @V_QTBRUTINSPRO_NEW,
    				 @V_VRPRENDINSPR_NEW,
    				 @V_VRCUSTPRODMM_NEW,
    			 	 @V_VRCUSTEQUIMM_NEW,
    				 @V_VRCUSTRDELMM_NEW;

   END;

   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;

END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_CDP_COMPPROD','5.07.000';
GO
